using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
namespace ClassificationApplication.FeatureExtractor
{
    /**<summary>Encapsulates a phrase and necessary information</summary>*/
    class ExtractorWord
    {
        public string phrase;
        private Regex regex;

        public Regex Regex
        {
            get { return regex; }
        }
        private double weight;

        public double Weight
        {
            get { return weight; }
        }

        string urlSource;

        /**<summary>Constructor</summary>
         * <param name="absolutePos">The posistion of the word in the document</param>
         * <param name="sentenceNo">The number of the sentence containing the word</param>
         * <param name="sentencePos">The words position inside the sentence</param>
         * <param name="word">The word as a string</param>
         * <param name="wordClass">The words part-of-speech</param>
         */

        public ExtractorWord(string phrase, Regex regex, string urlSource) 
        {
            this.urlSource = urlSource;
            this.phrase = phrase;
            this.regex = regex;
            this.weight = Globals.URLSourceWeight(urlSource);
        }

        public void IncrementCount(string urlSource)
        {
            weight+=Globals.URLSourceWeight(urlSource); 
        }
    }
}
