using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace ClassificationApplication.FeatureExtractor
{
    public class Globals
    {
        public static bool doTFIDFWeighting = false;
        public static bool doWordLengthBoost = true;
        public static bool doMultiWordPhraseBoost = true;
        public static bool doNormalizeWeights = true;

        public static double wordLengthBoostFactor = 10.0d;//20.0d;//The higher value of this varibale, the lower effect of the boost.

        private static string[] searchFields = new string[] { "title", "ingress"/*, "paragraph" */};

        public static string[] SearchFields
        {
            get { return searchFields; }
        }
        private static readonly string[] taggedFields = new string[] { "titleTagged", "ingressTagged"/*, "paragraphTagged" */};

        public static string[] TaggedFields
        {
            get { return Globals.taggedFields; }
        } 

        private static string nounRegex = "\\bNN\\w*";
        private static Regex phraseRegex = new Regex("(" + nounRegex + "\\s|JJ\\w\\s)*" + nounRegex);
        //private static Regex phraseRegex = new Regex("\\b\\w\\w\\s");
        public static Regex PhraseRegex
        {
            get { return Globals.phraseRegex; }
        }
        private static Regex companyRegex = new Regex("(\\bNNPC\\s)*NNPC");

        public static Regex CompanyRegex
        {
            get { return Globals.companyRegex; }
        }
        private static Regex personRegex = new Regex("(\\bNNPP\\s)*NNPP");

        public static Regex PersonRegex
        {
            get { return Globals.personRegex; }
        }
        private static Regex[] posRegex = new Regex[] { PhraseRegex, CompanyRegex, PersonRegex };

        public static Regex[] PosRegex
        {
            get { return Globals.posRegex; }
        }

        public static double MultiWordPhraseBoost(Regex regex)
        {
            if (regex == CompanyRegex)
                return 1.0d;
            else if (regex == PersonRegex)
                return 1.5d;
            else if (regex == PhraseRegex)
                return 2.5d;
            return 1.0d;
        }

        public static double URLSourceWeight(string source)
        {
            if (source.Equals("www.hegnar.no"))
                return 0.8d;
            else if (source.Equals("pub.tv2.no"))
                return 0.8d;
            else if (source.Equals("www.imarkedet.no"))
                return 0.8d;
            else if (source.Equals("www.dn.no"))
                return 1.1d;
            else if (source.Equals("www.aftenposten.no"))
                return 1.05d;
            else if(source.Equals("www.siste.no"))
             return 0.9d;
                /*
            else if(source.Equals())
            else if(source.Equals())
            else if(source.Equals())
             */
            else
                return 1.0d;
        }
    }
}
