using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using ClassificationApplication.FeatureExtractor;

namespace ClassificationApplication.FeatureExtractor.IndexComparator
{
    public class Comparator
    {
        public static double Compare(Index index1, Index index2) 
        {
            ICollection keys = index1.GetKeys();
            double weightProd = 0.0;
            foreach (string key in keys) 
            {
                if (index2.ContainsKey(key)) {
                    weightProd += index1.GetWeight(key) * index2.GetWeight(key);
                }
            }
            double norm = Math.Sqrt(index1.GetNorm()) * Math.Sqrt(index2.GetNorm());
            double compareValue = weightProd / norm;
            return compareValue;
        }
        public static SortedList<double,string> SortWords(Index index)
        {
            ICollection keys = index.GetKeys();
            SortedList<double, string> sortedList = new SortedList<double, string>();
            double weight;
            foreach (string key in keys)
            {
                weight = index.GetWeight(key);
                while (sortedList.ContainsKey(weight))
                {
                    weight += .0001d;
                }
                if (weight > 0.1)
                {
                    sortedList[weight] = key;
                }
            }
            return sortedList;
        }
    }
}
