using System;
using System.Collections;
using System.Text;
using System.Data.SqlClient;
using System.Data;
namespace NewsFetcher.ArticleFetcher
{
    class ArticleStore
    {
        private SqlConnection conn;
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        
        public ArticleStore()
        {
            log.Info("Initializing ArticleStore");
            conn = new SqlConnection();
            conn.ConnectionString = "Data Source=tcp:129.241.102.186,1500;Initial Catalog=newsdatabase;User ID=databaseuser;Password=databasebruker1;";
        }

        public void StoreArticle(Article article)
        {
            try
            {
                conn.Open();
                this.StoreArticleInDB(article);
                this.StoreParagraphsInDB(article);
            }
            catch (InvalidOperationException ioe)
            {
                log.Error("Failed to perform operation: " + ioe.Message);
            }
            catch (System.Data.SqlClient.SqlException ex)
            {
                log.Error("Failed to connect to data source: " + ex.Message);
            }
            finally
            {
                conn.Close();
            }
        }
        public Boolean IsArticleStored(string url)
        {
            conn.Open();
            SqlCommand selectCommand;
            SqlDataReader reader;
            string selectString = "select url from newsArticle where url = '" + url + "';";

            selectCommand = new SqlCommand(selectString, conn);
            
            reader = selectCommand.ExecuteReader();

            if (reader.HasRows)
            {
                reader.Close();
                conn.Close();
                return true;
            }
            reader.Close();
            conn.Close();
            return false;
        }
        private void StoreArticleInDB(Article article)
        {
            SqlCommand selectCommand;
            SqlCommand insertCommand;
            SqlDataReader reader;
            string selectString = "select url from newsArticle where url = '" + article.Url + "';";

            selectCommand = new SqlCommand(selectString, conn);
            reader = selectCommand.ExecuteReader();

            if (!reader.HasRows)
            {
                reader.Close();
                string insertString = "insert into newsArticle values('" + article.Url +  "','" + article.Title + "','" + article.Ingress + "');";
                insertCommand = new SqlCommand(insertString, conn);
                insertCommand.ExecuteNonQuery();
                log.Info("Stored article in database successfully: \n" + article);
            }
            else
            {
                log.Warn("Article-object already stored:\n" + article.Url);
            }
            reader.Close();
        }
        private void StoreParagraphsInDB(Article article)
        {
            SqlCommand selectCommand;
            SqlDataReader reader;
            
            string selectString = "select url, p_id from newsParagraph where url = '" + article.Url + "';";
            selectCommand = new SqlCommand(selectString, conn);
            reader = selectCommand.ExecuteReader();

            if (!reader.HasRows)
            {
                reader.Close();
                SqlCommand insertCommand;
                string insertString;

                int i = 0;
                foreach (string paragraph in article.Paragraphs)
                {
                    insertString = "insert into newsParagraph values('" + article.Url + "','" + i + "','" + paragraph + "');";
                    insertCommand = new SqlCommand(insertString, conn);
                    insertCommand.ExecuteNonQuery();
                    i++;
                }

                log.Info("Stored article-paragraphs in database successfully: \n" + article.Url + ". Number of paragraphs: " + i);
            }
            else
            {
                log.Warn("Paragraph-objects already stored:\n" + article.Url);
            }
            reader.Close();
        }
        public Article FetchArticleFromDB(string url)
        {
            ArrayList paragraphs = FetchParagraphsFromDB(url);

            SqlCommand selectCommand;
            SqlDataAdapter paragraphsAdapter;
            DataSet paragraphsSet = new DataSet();
            ArrayList paragraphList = new ArrayList();

            string selectString = "select title, ingress from newsArticle " +
            "where url like '" + url + "';";

            selectCommand = new SqlCommand(selectString, conn);
            paragraphsAdapter = new SqlDataAdapter(selectCommand);

            conn.Open();
            paragraphsAdapter.Fill(paragraphsSet);

            DataTable dataTable = paragraphsSet.Tables[0];

            if (dataTable.Rows.Count == 0)
            {
                conn.Close();
                throw new ArticleNotFoundInDBException();
            }
            else
            {
                string title = dataTable.Rows[0][0].ToString();
                string ingress = dataTable.Rows[0][1].ToString();
                conn.Close();

                string[] paragraphArray = (String[])paragraphs.ToArray(typeof(String));
                return new Article(url, title, ingress, paragraphArray);
            }
        }
        private ArrayList FetchParagraphsFromDB(string url)
        {
            SqlCommand selectCommand;
            SqlDataAdapter paragraphsAdapter;
            DataSet paragraphsSet = new DataSet();
            ArrayList paragraphList = new ArrayList();

            string selectString = "select text from newsParagraph " +
            "where url like '" + url + "' " +
            "order by p_id asc;";

            selectCommand = new SqlCommand(selectString, conn);
            paragraphsAdapter = new SqlDataAdapter(selectCommand);

            conn.Open();
            paragraphsAdapter.Fill(paragraphsSet);

            DataTable dataTable = paragraphsSet.Tables[0];

            foreach (DataRow row in dataTable.Rows)
            {
                paragraphList.Add(row[0].ToString());
            }
            conn.Close();

            return paragraphList;
        }
        public ArrayList FetchUrlsFromDB(DateTime startTime, DateTime endTime)
        {
            
            SqlCommand selectCommand;
            SqlDataAdapter paragraphsAdapter;
            DataSet paragraphsSet = new DataSet();
            ArrayList urlList = new ArrayList();

            string selectString = "select url from rssNews " +
            "where date_stored > '" + startTime + "' " +
            "and date_stored < '"+ endTime + "' ;";

            selectCommand = new SqlCommand(selectString, conn);
            paragraphsAdapter = new SqlDataAdapter(selectCommand);

            conn.Open();
            paragraphsAdapter.Fill(paragraphsSet);

            DataTable dataTable = paragraphsSet.Tables[0];

            foreach (DataRow row in dataTable.Rows)
            {
                urlList.Add(row[0].ToString());
            }
            conn.Close();
            return urlList;
        }
        /*
        public static void main(String[] args)
        {
            ArticleStore store = new ArticleStore();
            store.FetchArticleFromDB("noUrl");
        }
         */ 
    }
}
