using System;
using System.Collections.Generic;
using System.Text;

namespace NewsFetcher
{
    class Fetcher : System.ServiceProcess.ServiceBase
    {
        RSSFetcher rssFetcher;
        
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        
        public Fetcher() 
        {
            rssFetcher = new RSSFetcher();

        }
        
        protected override void OnStop()
        {
            while (rssFetcher.Fetching)
            {
                System.Threading.Thread.Sleep(1000);
            }
            rssFetcher.Running = false;
            log.Info("RSSFetcher stopped");
            base.OnStop();
        }
        protected override void OnShutdown()
        {
            while (rssFetcher.Fetching)
            {
                System.Threading.Thread.Sleep(1000);
            }
            rssFetcher.Running = false; 
            log.Info("Shutting down");
            base.OnShutdown();
        }
        protected override void OnContinue()
        {
            rssFetcher.Running = true;
            log.Info("Continue running");
            base.OnContinue();
        }
        protected override void OnStart(string[] args)
        {
            log.Info("Starting service");
            rssFetcher.Running = true;
            //rssFetcher = new RSSFetcher();
            //base.OnStart(args);
        }

        private void InitializeComponent()
        {
            // 
            // RssFetcher
            // 
            this.CanHandlePowerEvent = true;
            this.CanHandleSessionChangeEvent = true;
            this.CanPauseAndContinue = true;
            this.CanShutdown = true;
            this.ServiceName = "RssFetcher";

        }
    }
}
