using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.Data.SqlClient;
using System.Threading;
using Rss;

namespace NewsFetcher.ArticleFetcher
{

    public class RSSFetcher
    {
        private System.Data.SqlClient.SqlConnection conn;
        private ArrayList feedList;
        private RssFeed feed;
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger("NewsFetcher.ArticleFetcher.RssFetcher");
        private ArticleFetcher articleFetcher;
        private Boolean running;
        private Boolean fetching;

        
        public bool Fetching
        {
            get { return fetching; }
        }

        public bool Running
        {
            get { return running; }
            set { running = value; }//TODO: Br vi interrupte trden og?
        }

        public RSSFetcher()
        {
            log.Info(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
            articleFetcher = new ArticleFetcher();
            conn = new System.Data.SqlClient.SqlConnection();
            conn.ConnectionString = "Data Source=tcp:129.241.102.186,1500;Initial Catalog=newsdatabase;User ID=databaseuser;Password=databasebruker1;";
            feedList = new ArrayList();
            feedList.Add("http://www.aftenposten.no/eksport/rss-1_0/?seksjon=nyheter_okonomi");
            //feedList.Add("http://www.nrk.no/nyheiter/okonomi/siste.rss");//Fjernet grunnet parseproblemer (drittjobb, vanskelig  finne et fast mnster)
            feedList.Add("http://dn.no/rss/3.0?limit=100");
            feedList.Add("http://www.hegnar.no/hoxmlfeed/rss_feed.asp?cat=100");
            feedList.Add("http://www.hegnar.no/hoxmlfeed/rss_feed.asp?cat=103");
            feedList.Add("http://www.hegnar.no/hoxmlfeed/rss_feed.asp?cat=116");
            feedList.Add("http://www.imarkedet.no/phpf/feed/rss/imarkedet_analyser.php");
            feedList.Add("http://www.imarkedet.no/phpf/feed/rss/imarkedet_nyheter.php");
            feedList.Add("http://www.siste.no/rss/innenriks/naringsliv/index.xml");
            feedList.Add("http://pub.tv2.no/nettavisen/ut/rss/nabors.xml");
            feedList.Add("http://pub.tv2.no/nettavisen/ut/rss/naokonomi.xml");
            running = true;
            fetching = false;
            //Thread rssThread = new Thread(new ThreadStart(RunRssFetching));
            //RunRssFetching();
            //rssThread.Start();
        }

        public void RunRssFetching()
        {
            Thread newThread;
            while (running)
            {
                newThread = new Thread(new ThreadStart(FetchUrls));
                newThread.Start();

                System.Threading.Thread.Sleep(1000 * 60 * 5);//5 minutter
                log.Info(System.DateTime.Now + " Running a new iteration");
            }
        }

        private void FetchUrls()
        {
            fetching = true;
            foreach (string uri in feedList)
            {
                FetchUrl(uri);
            }
            fetching = false;
        }

        private void FetchUrl(string url)
        {
            SqlCommand sqlCommand;
            string selectString;
            string insertString;
            SqlDataReader reader;

            try
            {
                feed = RssFeed.Read(url);
                conn.Open();
                foreach (RssChannel channel in feed.Channels)
                {
                    foreach (RssItem item in channel.Items)
                    {
                        if (item.PubDate.Year < 2000)
                        {
                            item.PubDate = System.DateTime.Now;
                        }

                        selectString = "select url from rssNews where url like '" + item.Link + "';";
                        sqlCommand = new SqlCommand(selectString, conn);
                        reader = sqlCommand.ExecuteReader();

                        if (!reader.HasRows)
                        {
                            reader.Close();
                            while (item.Title.Contains("'"))
                            {
                                item.Title = item.Title.Replace("'", " ");
                            }
                            while (item.Description.Contains("'"))
                            {
                                item.Description = item.Description.Replace("'", " ");
                            }
                            item.Description = ArticleFetcher.RemoveTags(item.Description);
                            insertString = "insert into rssNews values('" + item.Title + "','" + item.Description + "','" + item.Link + "','" + item.PubDate + "','" + item.Author + "','" + System.DateTime.Now + "','" + url + "');";
                            sqlCommand = new SqlCommand(insertString, conn);
                            sqlCommand.ExecuteNonQuery();
                            log.Info("Inserted a new RSS-item:\n" +
                                "Tittel " + item.Title +
                                "\n Link " + item.Link +
                                "\n PubDate " + item.PubDate +
                                "\n Description " + item.Description +
                                "\n Author " + item.Author);
                            try
                            {
                                articleFetcher.FetchNewsArticle(item.Link.ToString());
                            }
                            catch (ArticleNotFoundInDBException anfe)
                            {
                                log.Error(anfe);
                            }

                        }
                        reader.Close();
                    }
                }
            }

            catch (Exception ex)
            {
                log.Error("Failed to connect to data source: " + ex.Message);
            }
            finally
            {

                conn.Close();
            }
        }

        
        /*
        public static void Main()
        {
            new RssFetcher();
            /*
            ArticleFetcher fetcher = new ArticleFetcher();
            fetcher.FetchOldArticles(new System.DateTime(2006, 1, 1), new System.DateTime(2006, 4, 1));
            */
            /*
          ArticleStore store = new ArticleStore();
            
          try
          {
              store.FetchArticleFromDB("noUrl");
          }
          catch (ArticleNotFoundInDBException anfe)
          {
          }
              
          Console.WriteLine(
          store.FetchArticleFromDB("http://www.hegnar.no/hegnar/newsdet.asp?id=210164"));
           *//*
        }*/
    }
}
