using System;
using System.Net;
using System.IO;
using System.Text;
using System.Collections;
using MIL.Html;

namespace StockFetcher
{
    struct Company
    {
        public string name, ticker;

        public Company(string name, string ticker)
        {
            this.name = name;
            this.ticker = ticker;
        }
    }

    class ParseStockCompanies
    {
        public static ArrayList GetStockCompanies(String url)
        {
            ArrayList companies = new ArrayList();
            string content = GetHTMLFromURL(url);
            HtmlDocument doc = HtmlDocument.Create(content);
            string body = doc.Nodes[2].HTML.ToString();
            int nextCompanyIndex = 0;
            int tmpIndex;
            string companyName;
            string companyTicker;
            nextCompanyIndex = body.IndexOf("companyInfo&");

            while (nextCompanyIndex > -1)
            {
                body = body.Substring(nextCompanyIndex);
                body = body.Substring(body.IndexOf(">") + 1);
                tmpIndex = body.IndexOf("</a>");
                companyName = body.Substring(0, tmpIndex);
                body = body.Substring(body.IndexOf("<td><font face=") + 10);
                body = body.Substring(body.IndexOf(">") + 1);
                tmpIndex = body.IndexOf("</font>");
                companyTicker = body.Substring(0, tmpIndex);
                Console.WriteLine("Selskap: {0}. Ticker: {1}", companyName, companyTicker);
                companies.Add(new Company(companyName, companyTicker));
                nextCompanyIndex = body.IndexOf("companyInfo&");
            }
            Console.WriteLine(companies.Count);
            return companies;
        }

        public static string GetHTMLFromURL(string url)
        {
            if (url.Length == 0)
                throw new ArgumentException("Invalid URL", "url");

            string html = "";
            HttpWebRequest request = GenerateGetOrPostRequest(url, "GET", null);
            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            try
            {
                Stream responseStream = response.GetResponseStream();
                StreamReader reader = new StreamReader(responseStream, UTF8Encoding.UTF8);

                try
                {
                    html = reader.ReadToEnd();
                }
                finally
                {
                    reader.Close();
                }
            }
            finally
            {
                response.Close();
            }
            return html;
        }

        public static HttpWebRequest GenerateGetOrPostRequest(string uriString, string method, string postData)
        {
            if ((method.ToUpper() != "GET") &&
                (method.ToUpper() != "POST"))
                throw new ArgumentException(method + " is not a valid method.  Use GET or POST.", "method");
            HttpWebRequest httpRequest = null;
            Uri uri = new Uri(uriString);
            // create the initial request
            httpRequest = (HttpWebRequest)WebRequest.Create(uri);

            if (method.ToUpper() == "POST")
            {
                byte[] bytes = UTF8Encoding.UTF8.GetBytes(postData);
                httpRequest.ContentType = "application/x-www-form-urlencoded";
                httpRequest.ContentLength = postData.Length;
                Stream requestStream = httpRequest.GetRequestStream();
                requestStream.Write(bytes, 0, bytes.Length);
                requestStream.Close();
            }
            return httpRequest;
        }
        
        
        static void Main(string[] args)
        {
            ParseStockCompanies.GetStockCompanies("http://www.stocklink.no/quotes.html");
            Console.WriteLine("Finito");


            Console.WriteLine("Dette er skrevet i offline-modus");
        }
         
    }
	
	
}
