using System;
using System.Collections.Generic;
using System.Text;
using System.Net;

namespace Tagger.PropernameStore.Fetcher
{
    class Crawler
    {
        Dictionary<string, string> urlsCrawled;
        List<string> personsCrawled;
        Fetcher.DBStore store ;
        public Crawler()
        {
            urlsCrawled = new Dictionary<string, string>();
            personsCrawled = new List<string>();
            store = new Fetcher.DBStore();
        }

        private string FetchWebPageContents(string url)
        {
            //System.Threading.Thread.Sleep(50);
            try
            {
                WebClient wc = new WebClient();
                Byte[] response = wc.DownloadData(url);
                string strWebContent = Encoding.Default.GetString(response);
                return strWebContent;
            }
            catch (System.ArgumentOutOfRangeException e)
            {
                Console.WriteLine("Exception caught: " + e);
                return "";
            }
            catch (System.Net.WebException e)
            {
                Console.WriteLine("Caught webexception " + e);
                return "";
            }
            
        }

        public void ExtractCompanies(string startUrl)
        {
            Dictionary<string, string> urlsToCrawl = ExtractSelskapsInformasjon(startUrl);
            bool crawl = true;
            Dictionary<string, string> tmpUrlsToCrawl = new Dictionary<string,string>();
            while (crawl)
            {
                foreach (string companyID in urlsToCrawl.Keys)
                {
                    if (!urlsCrawled.ContainsKey(companyID)&&!store.IsCompanyStored(companyID))
                    {
                        Dictionary<string,string> newUrlsToCrawl = ExtractSelskapsInformasjon(urlsToCrawl[companyID]);
                        foreach (string newCompanyId in newUrlsToCrawl.Keys)
                        {
                            if (!tmpUrlsToCrawl.ContainsKey(newCompanyId))
                            {
                                tmpUrlsToCrawl[newCompanyId] = newUrlsToCrawl[newCompanyId];
                            }
                            else { }
                        }
                    }
                }
                bool stop = true;
                foreach (string companyId in tmpUrlsToCrawl.Keys)
                {
                    if (!urlsToCrawl.ContainsKey(companyId) && !store.IsCompanyStored(companyId))
                    {
                        urlsToCrawl[companyId] = tmpUrlsToCrawl[companyId];
                        stop = false;
                    }
                }
                if (stop)
                {
                    crawl = false;
                }
                tmpUrlsToCrawl = new Dictionary<string, string>();
            }
        }
        private Dictionary<string,string> ExtractSelskapsInformasjon(string url)
        {
            Dictionary<string, string> urlsToCrawl = new Dictionary<string, string>();
            Selskap selskap = new Selskap();
            string info = FetchWebPageContents(url);
            //info = info.Substring(info.IndexOf("<div id=\"infosidehode\">"));
            info = info.Substring(info.IndexOf("infosidehode"));
            //info = info.Substring(0, info.IndexOf("<h2>Tjenester</h2>"/*"<div id=\"sidekolonne\">"*/));
            info = info.Substring(0, info.IndexOf("infosidetjenester"));
            if (info.Length > 1)
            {
                info = info.Substring(info.IndexOf("<li><a href=\"") + 13);
                try
                {
                    string linkRegnskapsTall = info.Substring(0, info.IndexOf("\">Regnskapstall</a></li>"));
                    info = info.Substring(info.IndexOf("<li><a href=\"") + 13);
                }
                catch (ArgumentOutOfRangeException ie) { }

                string linkRollerOgKunngjoringer = info.Substring(0, info.IndexOf("\">Roller og kunngj&oslash;ringer</a></li>"));
                linkRollerOgKunngjoringer = string.Concat("http://www.proff.no", linkRollerOgKunngjoringer);
                info = info.Substring(info.IndexOf("<div id=\"hovedkolonne\">"));
                string type;
                //info = info.Substring(info.IndexOf("<h2>") + 4);
                //string type = info.Substring(0, info.IndexOf("</h2>"));
                //info = info.Substring(info.IndexOf("</table>"));

                while (info.Contains("<h2>") /*&& info.Contains("</table>")*/)
                {
                    info = info.Substring(info.IndexOf("<h2>") + 4);
                    type = info.Substring(0, info.IndexOf("</h2>")).Trim();
                    if (type.ToLower().Equals("beskrivelse"))
                    {
                        string beskrivelse = info.Substring(0, info.IndexOf("</p>"));
                        beskrivelse = beskrivelse.Substring(beskrivelse.IndexOf("<p>") + 3);
                        Beskrivelse beskr = new Beskrivelse();
                        beskr.Tekst = beskrivelse;
                        selskap.Beskrivelse = beskr;
                    }
                    else if (type.ToLower().Equals("firma"))
                    {
                        string firma = info.Substring(0, info.IndexOf("</table>"));
                        selskap.Firma = ExtractFirmaData(firma);
                    }
                    else if (type.ToLower().Equals("offisiell foretaksinformasjon"))
                    {
                        string foretaksInformasjon = info.Substring(0, info.IndexOf("</table>"));
                        selskap.Foretaksinformasjon = ExtractForetaksInformasjon(foretaksInformasjon);
                    }
                    else if (type.ToLower().Equals("fagomrde/bransjer"))
                    {
                        string fB = info.Substring(0, info.IndexOf("</table>"));
                        selskap.FagomradeBransje = ExtractFagBransje(fB);
                    }
                    else if (type.ToLower().Equals("katalogoppfring"))
                    {
                        //Unyttig informasjon..
                    }
                    else if (type.ToLower().Equals("andre firma i samme bransje"))
                    {
                        string competitorString = info.Substring(info.IndexOf("</h2>"));
                        Dictionary<string, string> competitors = ExtractAndreFirmaISammeBransje(competitorString);
                        foreach (string competitorKey in competitors.Keys)
                        {
                            if (!urlsToCrawl.ContainsKey(competitorKey))
                            {
                                urlsToCrawl[competitorKey] = competitors[competitorKey];
                            }
                        }
                    }
                    else
                    {
                        Console.WriteLine("ExtractSelskapsinformasjon(): Dette skal ikke skje!!!");
                    }
                    info = info.Substring(info.IndexOf("</h2>"));
                    /*
                    if (info.Contains("</table>"))
                    {
                        info = info.Substring(info.IndexOf("</table>"));
                    }*/
                }
                info = FetchWebPageContents(linkRollerOgKunngjoringer);
                info = info.Substring(info.IndexOf("<div id=\"hovedkolonne\">"));
                try
                {
                    info = info.Substring(0, info.IndexOf("<h2>Kunngj&oslash;ringer fra Br&oslash;nn&oslash;ysundregistrene</h2>"));
                    if (info.Length > 1)
                    {
                        selskap.Personer = ExtractRoller(info);
                    }
                }
                catch (ArgumentOutOfRangeException e) { }
            }
            else
            {
                Console.Error.WriteLine("Noe gikk galt!!!");
            }
            
            if (selskap.Foretaksinformasjon.OrganisasjonsNr != null)
            {
                store.StoreCompany(selskap);
                urlsCrawled[selskap.Foretaksinformasjon.OrganisasjonsNr] = url;
                foreach (DatterSelskap datterSelskap in selskap.Foretaksinformasjon.DatterSelskaper)
                {
                    if (datterSelskap.Link != null)
                    {
                        urlsToCrawl[datterSelskap.OrgNr] = datterSelskap.Link;
                    }
                }

            }
            /*
            foreach (string company in urlsToCrawl.Keys)
            {//TODO: FLytt i egen metode (se foreach nedenfor, lik)
                if (!urlsCrawled.ContainsKey(company))
                {
                    ExtractSelskapsInformasjon(urlsToCrawl[company]);
                }
            }
             */
            if (selskap.Personer != null)
            {
                foreach (Person p in selskap.Personer)
                {
                    if (!personsCrawled.Contains(p.Id))
                    {
                        /*
                         * Her m man g til "Infoside"-linken
                         * Lag personsToCrawl-Dictionary for  unng evig lkke (ta vare p personid).
                         */
                        Dictionary<string, string> tmpUrlsToCrawl = ExtractRelatedCompanies(p.Link);
                        foreach (string key in tmpUrlsToCrawl.Keys)
                        {
                            if (!urlsToCrawl.ContainsKey(key))
                            {
                                urlsToCrawl[key] = tmpUrlsToCrawl[key];
                            }
                        }
                        personsCrawled.Add(p.Id);
                    }
                }
            }
            Console.WriteLine(selskap.Foretaksinformasjon.JuridiskSelskapsnavn);
            return urlsToCrawl;
        }

        private Dictionary<string,string> ExtractRelatedCompanies(string url)
        {
            string content = FetchWebPageContents(url);
            content = content.Substring(content.IndexOf("<tbody class=\"navneliste\">"));
            content = content.Substring(0, content.IndexOf("</tbody>"));

            Dictionary<string,string> companyLinks = new Dictionary<string,string>();
            string company;
            string link;
            while (content.Contains("<a href="))
            {
                company = content.Substring(content.IndexOf("<a href=\"") + 9);
                content = content.Substring(content.IndexOf("<a href") + 5);
                string orgID = company.Substring(company.IndexOf("org=") + 4);
                orgID = orgID.Substring(0, orgID.IndexOf("&"));
                if (!urlsCrawled.ContainsKey(orgID))
                {
                    link = string.Concat("http://www.proff.no/proff/search/", company.Substring(0, company.IndexOf("\">")));
                    link = ExtractLinkFromRolesTab(link);
                    company = company.Substring(company.IndexOf("\">") + 2);
                    company = company.Substring(0, company.IndexOf("</a>"));
                    if (link.Length > 5)
                    {
                        companyLinks[orgID] = link;
                    }
                }
                content = content.Substring(content.IndexOf("</a>"));
            }
            return companyLinks;

        }

        private string ExtractLinkFromRolesTab(string link)
        {
            try
            {
                string content = FetchWebPageContents(link);
                content = content.Substring(content.IndexOf("<div id=\"infosidehode\">"));
                content = content.Substring(0, content.IndexOf("\">Infoside"));
                content = string.Concat("http://www.proff.no", content.Substring(content.IndexOf("<a href=\"") + 9));
                return content;
            }
            catch (ArgumentOutOfRangeException e)
            {
                return "";
            }
        }

        private List<Person> ExtractRoller(string info)
        {
            List<Person> personer = new List<Person>();
            try
            {
                info = info.Substring(info.IndexOf("<h2>Roller</h2>"));
                info = info.Substring(0, info.IndexOf("</table>"));
            }
            catch (ArgumentOutOfRangeException ae) { }

            while (info.Contains("<tr>") && info.Contains("</tr>"))
            {
                info = info.Substring(info.IndexOf("<tr>")+4);
                Person person = new Person();
                string rolle = info.Substring(info.IndexOf("<th>") + 4);
                rolle = rolle.Substring(0, rolle.IndexOf("</th>"));
                person.Rolle = rolle;
                string navn = info.Substring(info.IndexOf("<td>") + 4);
                navn = navn.Substring(0, navn.IndexOf("</td>")).Trim();
                if (navn.Contains("<a href"))
                {
                    navn = navn.Substring(navn.IndexOf("<a href=\"") + 9);
                    string link = navn.Substring(0, navn.IndexOf("\">"));
                    link = string.Concat("http://www.proff.no",link);
                    person.Link = link;
                    string id = link.Substring(link.IndexOf("&id=") + 4);
                    person.Id = id;
                    navn = navn.Substring(navn.IndexOf("\">")+2);
                    navn = navn.Substring(0, navn.IndexOf("</a>"));
                }
                /*
                else
                {
                    Console.WriteLine("Dette var da jvlig crap!\n"+navn+"\t"+rolle);
                }
                 */ 
                if (navn.Contains("("))
                {
                    navn = navn.Substring(0, navn.IndexOf("("));
                }
                person.Navn = navn;
                if (person.Link != null)
                {
                    personer.Add(person);
                }
                info = info.Substring(info.IndexOf("</tr>")+5);
            }
            return personer;
        }

        private Dictionary<string,string> ExtractAndreFirmaISammeBransje(string andreSelskaper)
        {
            Dictionary<string, string> andreSelskap = new Dictionary<string, string>();
            string orgNr;
            string selskapLink;
            while (andreSelskaper.Contains("<tr>"))
            {
                selskapLink = "";
                orgNr = andreSelskaper.Substring(andreSelskaper.IndexOf("<td>") + 4);
                orgNr = orgNr.Substring(0, orgNr.IndexOf("</td>"));

                if (orgNr.Contains("<a href"))
                {
                    selskapLink = orgNr.Substring(orgNr.IndexOf("<a href=\"") + 9);
                    selskapLink = selskapLink.Substring(0, selskapLink.IndexOf("\">"));
                    selskapLink = string.Concat("http://www.proff.no", selskapLink);

                    orgNr = orgNr.Substring(orgNr.IndexOf("org%3D")+6,9);
                    //orgNr = orgNr.Substring(0, orgNr.IndexOf("</a>"));
                } 
                andreSelskap[orgNr.Trim()] = selskapLink.Trim();
                andreSelskaper = andreSelskaper.Substring(andreSelskaper.IndexOf("</tr>") + 5);
            }
            return andreSelskap;
        }
        private FagomradeBransje ExtractFagBransje(string info)
        {
            FagomradeBransje fagomradeBransje = new FagomradeBransje();
            List<string> kategori;
            string key;
            string data;

            while (info.ToLower().Contains("<tr>"))
            {
                kategori = new List<string>();
                info = info.Substring(info.IndexOf("<tr>") + 4);
                key = info.Substring(info.IndexOf("<th>") + 4);
                key = key.Substring(0, key.IndexOf("</th>")).Replace("&oslash;", "").ToLower().Trim();

                //data = info.Substring(info.IndexOf("<td>") + 4);
                data = info.Substring(0, info.IndexOf("</tr>"));
                info = info.Substring(info.IndexOf("</tr>"));

                if (key.Equals("bransje") || key.Contains("nace-bransje") || key.Contains("nkkelord"))
                {
                    while (data.Contains("<li>"))
                    {
                        data = data.Substring(data.IndexOf("<li>") + 4);
                        string listElement = data.Substring(0, data.IndexOf("</li>"));
                        if (listElement.Contains("<a href"))
                        {
                            listElement = listElement.Substring(listElement.IndexOf(">") + 1);
                            listElement = listElement.Substring(0, listElement.IndexOf("</a>"));
                        }
                        listElement = listElement.Trim();
                        if (listElement.Trim().Length > 1 && !listElement.ToLower().Contains("treff i alfabetisk oversikt"))
                        {
                            kategori.Add(listElement);
                        }
                    }
                    if (key.Equals("bransje"))
                    {
                        fagomradeBransje.Bransje = kategori;
                    }
                    else if (key.Contains("nace-bransje"))
                    {
                        fagomradeBransje.NaceBransje = kategori;
                    }
                    else if (key.Contains("nkkelord"))
                    {
                        if (kategori == null)
                        {
                            kategori = new List<string>();
                        }
                        else
                        {
                            fagomradeBransje.NokkelOrd = kategori;
                        }
                    }
                }
                else if (key.ToLower().Contains("cpv-bransje"))
                {
                    while (data.Contains("<dt>"))
                    {
                        data = data.Substring(data.IndexOf("<dt>") + 4);
                        string dataElement = data.Substring(0, data.IndexOf("</dt>"));
                        if (dataElement.Contains("<a href"))
                        {
                            dataElement = dataElement.Substring(dataElement.IndexOf(">") + 1);
                            dataElement = dataElement.Substring(0, dataElement.IndexOf("</a>"));
                        }
                        dataElement = dataElement.Trim();
                        if (dataElement.Trim().Length > 1)
                        {
                            kategori.Add(dataElement);
                        }
                    }
                    fagomradeBransje.CpvBransje = kategori;
                }
                else
                {
                    Console.WriteLine("Fang opp dette!!! (ExtractFagBransje())");
                }
            }
            return fagomradeBransje;
        }
        private Firma ExtractFirmaData(string info)
        {
            Firma firma = new Firma();
            //Dictionary<string, string> firmaInfo = new Dictionary<string, string>();
            string key;
            string data;

            while (info.ToLower().Contains("<tr>"))
            {
                info = info.Substring(info.IndexOf("<tr>"));
                key = info.Substring(info.IndexOf("<th>") + 4);
                key = key.Substring(0, key.IndexOf("</th>")).ToLower();
                data = info.Substring(info.IndexOf("<td>") + 4);
                data = data.Substring(0, data.IndexOf("</td>"));
                if (data.Contains("<a href"))
                {
                    data = data.Substring(data.IndexOf(">") + 1);
                    data = data.Substring(0, data.IndexOf("</a>"));
                }
                info = info.Substring(info.IndexOf("</tr>"));
                if (key.Equals("markedsnavn"))
                { firma.Markedsnavn = data; }
                else if (key.Equals("e-post")) { firma.EPost = data; }
                else if (key.Equals("hjemmeside")) { firma.Hjemmeside = data; }
                else if (key.Equals("telefon")) { firma.Telefon = data; }
                else if (key.Equals("telefaks")) { firma.Telefaks = data; }
                else if (key.Equals("gateadresse")) { firma.GateAdresse = data; }
                else if (key.Equals("postadresse")) { firma.PostAdresse = data; }
                else if (key.Equals("pningstider")) { firma.Apningstider = data; }
                else if (key.Equals("referanser")) { firma.Referanser = data; }
                else { Console.WriteLine("ExtractFirmadata(): Unknown pattern"); }
                //firmaInfo[key] = data;
            }
            return firma;
        }
        private ForetaksInformasjon ExtractForetaksInformasjon(string info)
        {
            ForetaksInformasjon foretaksInfo = new ForetaksInformasjon();

            string key;
            List<DatterSelskap> datterSelskaper = new List<DatterSelskap>();
                    

            while (info.ToLower().Contains("<tr>"))
            {
                info = info.Substring(info.IndexOf("<tr>"));
                key = info.Substring(info.IndexOf("<th>") + 4);
                key = key.Substring(0, key.IndexOf("</th>")).ToLower();

                if (key.Contains("organisasjonsnr"))
                {
                    string orgNr = info.Substring(info.IndexOf("<td>") + 4);
                    orgNr = orgNr.Substring(0, orgNr.IndexOf("</td>")).Trim();
                    //orgNr = 
                    //Console.WriteLine(orgNr.Length);
                    foretaksInfo.OrganisasjonsNr = string.Concat(orgNr.Substring(0, 3), orgNr.Substring(4, 3), orgNr.Substring(8, 3)); ;
                }
                else if (key.Contains("juridisk selskapsnavn"))
                {
                    string selskapsNavn = info.Substring(info.IndexOf("<td>") + 4);
                    selskapsNavn = selskapsNavn.Substring(0, selskapsNavn.IndexOf("</td>"));
                    if (selskapsNavn.Contains("<a href"))
                    {
                        selskapsNavn = selskapsNavn.Substring(selskapsNavn.IndexOf(">") + 1);
                        selskapsNavn = selskapsNavn.Substring(0, selskapsNavn.IndexOf("</"));
                    }
                    selskapsNavn = selskapsNavn.Trim();
                    foretaksInfo.JuridiskSelskapsnavn = selskapsNavn;
                }
                else if (key.Contains("tidligere navn"))
                {
                    List<string> tidligereNavn = new List<string>();
                    while (info.Contains("<li>") && info.IndexOf("<li>") < info.ToLower().IndexOf("telefon"))
                    {
                        info = info.Substring(info.IndexOf("<li>") + 4);
                        string tNavn = info.Substring(0, info.IndexOf("</li>"));
                        tidligereNavn.Add(tNavn);
                        info = info.Substring(info.IndexOf("</li>"));
                    }
                    foretaksInfo.TidligereNavn = tidligereNavn;

                }
                else if (key.Contains("telefon"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string telefon = info.Substring(0, info.IndexOf("</td>"));
                    foretaksInfo.Telefon = telefon;
                }
                else if (key.Contains("telefaks"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string telefaks = info.Substring(0, info.IndexOf("</td>"));
                    foretaksInfo.Telefaks = telefaks;
                }
                else if (key.Contains("gateadresse"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string gateAdresse = info.Substring(0, info.IndexOf("</td>"));
                    foretaksInfo.GateAdresse = gateAdresse;
                }
                else if (key.Contains("postadresse"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string postAdresse = info.Substring(0, info.IndexOf("</td>"));
                    foretaksInfo.PostAdresse = postAdresse;
                }
                else if (key.Contains("aksjekapital"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string aksjeKapital = info.Substring(0, info.IndexOf("</td>"));
                    foretaksInfo.AksjeKapital = aksjeKapital;
                }
                else if (key.Contains("stiftelsesdato"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string stiftelsesDato = info.Substring(0, info.IndexOf("</td>"));
                    foretaksInfo.StiftelsesDato = stiftelsesDato;
                }
                else if (key.Contains("kontaktperson"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string kontaktPerson = info.Substring(0, info.IndexOf("</td>"));
                    if (kontaktPerson.Contains("|"))
                    {
                        kontaktPerson = kontaktPerson.Substring(0, kontaktPerson.IndexOf("|")).Trim();
                    }
                    foretaksInfo.KontaktPerson = kontaktPerson;
                }
                else if (key.Contains("antall ansatte"))
                {
                    info = info.Substring(info.IndexOf("<td>") + 4);
                    string antallAnsatte = info.Substring(0, info.IndexOf("</td>"));
                    foretaksInfo.AntallAnsatte = antallAnsatte;
                }
                else if (key.Contains("datterselskaper"))
                {
                    while (info.Contains("<li>"))
                    {
                        DatterSelskap ds = new DatterSelskap();
                        info = info.Substring(info.IndexOf("<li>") + 4);
                        string dSelskapsNavn = info.Substring(0, info.IndexOf("</li>"));

                        if (dSelskapsNavn.Contains("<a href=\""))
                        {
                            dSelskapsNavn = dSelskapsNavn.Substring(dSelskapsNavn.IndexOf("<a href=\"") + 9);
                            string dSelskapsLink = dSelskapsNavn.Substring(0, dSelskapsNavn.IndexOf("\">"));
                            ds.Link = string.Concat("http://www.proff.no/proff/search/", dSelskapsLink.Trim());
                            string orgNr = dSelskapsLink.Substring(dSelskapsLink.IndexOf("org=") + 4);
                            orgNr = orgNr.Substring(0, orgNr.IndexOf("&"));
                            ds.OrgNr = orgNr.Trim();
                            dSelskapsNavn = dSelskapsNavn.Substring(dSelskapsNavn.IndexOf("\">") + 2);
                            dSelskapsNavn = dSelskapsNavn.Substring(0, dSelskapsNavn.IndexOf("</a>"));
                            ds.SelskapsNavn = dSelskapsNavn;
                        }
                        //Console.WriteLine("DatterSelskap: " + dSelskapsNavn.Trim());
                        //Console.WriteLine(dSelskapsLink);
                        if (ds.Link != null && ds.SelskapsNavn != null && !datterSelskaper.Contains(ds))
                        {
                            datterSelskaper.Add(ds);
                        }
                        info = info.Substring(info.IndexOf("</li>"));
                    }
                }
                else
                {
                    Console.WriteLine("FANG OPP DENNE!!!\t" + key);
                }
                info = info.Substring(info.IndexOf("</tr>"));
            }

            foretaksInfo.DatterSelskaper = datterSelskaper;
            return foretaksInfo;
        }
    }
}
