using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace Tagger.PropernameStore.Fetcher
{
    public struct Selskap
    {
        Beskrivelse beskrivelse;
        public Beskrivelse Beskrivelse
        {
            get { return beskrivelse; }
            set { beskrivelse = value; }
        }
        Firma firma;
        public Firma Firma
        {
            get { return firma; }
            set { firma = value; }
        }
        ForetaksInformasjon foretaksinformasjon;
        public ForetaksInformasjon Foretaksinformasjon
        {
            get { return foretaksinformasjon; }
            set { foretaksinformasjon = value; }
        }
        FagomradeBransje fagomradeBransje;
        public FagomradeBransje FagomradeBransje
        {
            get { return fagomradeBransje; }
            set { fagomradeBransje = value; }
        }
        List<Person> personer;
        public List<Person> Personer
        {
            get { return personer; }
            set { personer = value; }
        }
    }
    public struct Beskrivelse
    {
        string tekst;
        public string Tekst
        {
            get { return tekst; }
            set { tekst = value; }
        }

    }
    public struct Firma
    {
        string markedsnavn;

        public string Markedsnavn
        {
            get { return markedsnavn; }
            set { markedsnavn = value; }
        }
        string ePost;

        public string EPost
        {
            get { return ePost; }
            set { ePost = value; }
        }
        string hjemmeside;

        public string Hjemmeside
        {
            get { return hjemmeside; }
            set { hjemmeside = value; }
        }
        string telefon;

        public string Telefon
        {
            get { return telefon; }
            set { telefon = value; }
        }
        string telefaks;

        public string Telefaks
        {
            get { return telefaks; }
            set { telefaks = value; }
        }
        string gateAdresse;

        public string GateAdresse
        {
            get { return gateAdresse; }
            set {
                while (value.Contains("'"))
                {
                    value = value.Replace("'", "");
                }
                gateAdresse = value; }
        }
        string postAdresse;

        public string PostAdresse
        {
            get { return postAdresse; }
            set {
                while (value.Contains("'"))
                {
                    value = value.Replace("'", "");
                }
                postAdresse = value; 
            }
        }
        string apningstider;

        public string Apningstider
        {
            get { return apningstider; }
            set { apningstider = value; }
        }
        string referanser;

        public string Referanser
        {
            get { return referanser; }
            set { referanser = value; }
        }
    }
    public struct ForetaksInformasjon
    {
        string organisasjonsNr;
        public string OrganisasjonsNr
        {
            get { return organisasjonsNr; }
            set { organisasjonsNr = value; }
        }
        string juridiskSelskapsnavn;
        public string JuridiskSelskapsnavn
        {
            get { return juridiskSelskapsnavn; }
            set
            {
                juridiskSelskapsnavn = "";
                foreach (string word in value.Split(' '))
                {
                    string tmpWord = word;
                    if (tmpWord.Contains("'"))
                    {
                        tmpWord = tmpWord.Replace("'", "");
                    }
                    juridiskSelskapsnavn = string.Concat(juridiskSelskapsnavn, " ", tmpWord);
                }
                juridiskSelskapsnavn = juridiskSelskapsnavn.Trim();
            }
        }
        List<string> tidligereNavn;
        public List<string> TidligereNavn
        {
            get { return tidligereNavn; }
            set { tidligereNavn = value; }
        }
        string telefon;
        public string Telefon
        {
            get { return telefon; }
            set { telefon = value; }
        }
        string telefaks;
        public string Telefaks
        {
            get { return telefaks; }
            set { telefaks = value; }
        }
        string gateAdresse;
        public string GateAdresse
        {
            get { return gateAdresse; }
            set
            {
                gateAdresse = "";
                foreach (string word in value.Split(' '))
                {
                    if (word.Contains("'"))
                    {
                        string tmpWord = word;
                        tmpWord = tmpWord.Replace("'", "");
                        gateAdresse = string.Concat(gateAdresse, " ", tmpWord);
                    }
                }
                gateAdresse = gateAdresse.Trim();
            }
        }
        string postAdresse;
        public string PostAdresse
        {
            get { return postAdresse; }
            set {
                while (value.Contains("'"))
                {
                    value = value.Replace("'", "");
                }
                postAdresse = value; }
        }
        string aksjeKapital;
        public string AksjeKapital
        {
            get { return aksjeKapital; }
            set { aksjeKapital = value; }
        }
        string stiftelsesDato;
        public string StiftelsesDato
        {
            get { return stiftelsesDato; }
            set { stiftelsesDato = value; }
        }
        string kontaktPerson;
        public string KontaktPerson
        {
            get { return kontaktPerson; }
            set { kontaktPerson = value; }
        }
        string antallAnsatte;
        public string AntallAnsatte
        {
            get { return antallAnsatte; }
            set { antallAnsatte = value; }
        }
        List<DatterSelskap> datterSelskaper;//<navn><link>
        public List<DatterSelskap> DatterSelskaper
        {
            get { return datterSelskaper; }
            set { datterSelskaper = value; }
        }
    }
    public struct DatterSelskap
    {
        string selskapsNavn;
        public string SelskapsNavn
        {
            get { return selskapsNavn; }
            set { selskapsNavn = value; }
        }
        string link;
        public string Link
        {
            get { return link; }
            set { link = value; }
        }
        string orgNr;
        public string OrgNr
        {
            get { return orgNr; }
            set { orgNr = value; }
        }
    }
    public struct FagomradeBransje
    {
        List<string> bransje;
        public List<string> Bransje
        {
            get { return bransje; }
            set { bransje = value; }
        }
        List<string> naceBransje;
        public List<string> NaceBransje
        {
            get { return naceBransje; }
            set { naceBransje = value; }
        }
        List<string> cpvBransje;
        public List<string> CpvBransje
        {
            get { return cpvBransje; }
            set { cpvBransje = value; }
        }
        List<string> nokkelOrd;
        public List<string> NokkelOrd
        {
            get { return nokkelOrd; }
            set { nokkelOrd = value; }
        }
    }
    public struct Person
    {
        string navn;
        public string Navn
        {
            get { return navn; }
            set { navn = value; }
        }
        string id;
        public string Id
        {
            get { return id; }
            set { id = value; }
        }
        string rolle;
        public string Rolle
        {
            get { return rolle; }
            set { rolle = value; }
        }
        string link;
        public string Link
        {
            get { return link; }
            set { link = value; }
        }
    }
}
