using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Lucene.Net.Index;
using Lucene.Net.Documents;
using Lucene.Net.Analysis;

namespace Tagger.PropernameStore
{
    public class PropernameIndexer
    {
        private static string indexDirectory = "c:\\index\\pcIndex";
        public static string IndexDirectory
        {
            get { return PropernameIndexer.indexDirectory; }
            set { PropernameIndexer.indexDirectory = value; }
        }
        private static string personsFile = "propernames\\persons.txt";
        public static string PersonsFile
        {
            get { return PropernameIndexer.personsFile; }
            set { PropernameIndexer.personsFile = value; }
        }
        private static string companiesFile = "propernames\\companies.txt";
        public static string CompaniesFile
        {
            get { return PropernameIndexer.companiesFile; }
            set { PropernameIndexer.companiesFile = value; }
        }

        private static void IndexPersons()
        {
            IndexWriter writer = new IndexWriter(IndexDirectory, new SimpleAnalyzer(), true);
            writer.SetMaxBufferedDocs(10000);
            writer.SetMergeFactor(1000);

            using (StreamReader reader = new StreamReader(PersonsFile,Encoding.Default))
            {
                string person;
                while ((person = reader.ReadLine()) != null)
                {
                    Document doc = new Document();
                    Field personField = new Field("data", person, true, true, true, true);
                    doc.Add(personField);
                    Field typeField = new Field("type", "person", true, false, false, false);
                    doc.Add(typeField);
                    doc.SetBoost(1.1f);
                    writer.AddDocument(doc);
                }
            }
            writer.Optimize();
            writer.Close();
        }

        private static void IndexCompanies()
        {//TODO: F dette til  g raskere!!!
            IndexWriter writer = new IndexWriter(IndexDirectory, new SimpleAnalyzer(), false);
            writer.SetMaxBufferedDocs(10000);
            writer.SetMergeFactor(1000);

            using (StreamReader reader = new StreamReader(CompaniesFile,Encoding.Default))
            {
                string company;
                while ((company = reader.ReadLine()) != null)
                {
                    Document doc = new Document();
                    Field companyField = new Field("data", company, true, true, true, true);
                    doc.Add(companyField);
                    Field typeField = new Field("type", "company", true, false, false, false);
                    doc.Add(typeField);
                    writer.AddDocument(doc);
                }
            }
            writer.Optimize();
            writer.Close();
        }

        public static void IndexProperNames()
        {
            IndexPersons();
            IndexCompanies();
        }
    }
}
